#include "SDLfonctions.h"

int SDLstart(unsigned int larg,unsigned int haut)
{
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }
    atexit(SDL_Quit);
    screen = SDL_SetVideoMode(larg, haut, 32,SDL_HWSURFACE|SDL_DOUBLEBUF);
    if ( !screen )
    {
        printf("Unable to set %dx%d video: %s\n", larg,haut,SDL_GetError());
        return 1;
    }
    return 0;
}


void setPixel(int x, int y, Uint32 coul)
{
    *((Uint32*)(screen->pixels) + x + y * screen->w) = coul;
}


void setPixelVerif(int x, int y, Uint32 coul)
{
    if (x >= 0 && x < screen->w &&
            y >= 0 && y < screen->h)
        setPixel(x, y, coul);
}
void barre(int x, int y, int w, int h, Uint32 coul)
{
    SDL_Rect r;

    r.x = x;
    r.y = y;
    r.w = w;
    r.h = h;

    SDL_FillRect(screen, &r, coul);
}

void effacerEcran(void)
{
    SDL_FillRect(screen, NULL, 0);
}
void ligneHorizontale(int x, int y, int w, Uint32 coul)
{
    SDL_Rect r;

    r.x = x;
    r.y = y;
    r.w = w;
    r.h = 1;

    SDL_FillRect(screen, &r, coul);
}

void rectangle(int x, int y, int w, int h, Uint32 coul)
{
    ligneHorizontale(x, y, w, coul);
    ligneHorizontale(x, y + h - 1, w, coul);
    ligneVerticale(x, y + 1, h - 2, coul);
    ligneVerticale(x + w - 1, y + 1, h - 2, coul);
}

void ligneVerticale(int x, int y, int h, Uint32 coul)
{
    SDL_Rect r;

    r.x = x;
    r.y = y;
    r.w = 1;
    r.h = h;

    SDL_FillRect(screen, &r, coul);
}


void echangerEntiers(int* x, int* y)
{
    int t = *x;
    *x = *y;
    *y = t;
}

void ligne(int x1, int y1, int x2, int y2, Uint32 coul)
{
    int d, dx, dy, aincr, bincr, xincr, yincr, x, y;

    if (abs(x2 - x1) < abs(y2 - y1))
    {

        if (y1 > y2)
        {
            echangerEntiers(&x1, &x2);
            echangerEntiers(&y1, &y2);
        }

        xincr = x2 > x1 ? 1 : -1;
        dy = y2 - y1;
        dx = abs(x2 - x1);
        d = 2 * dx - dy;
        aincr = 2 * (dx - dy);
        bincr = 2 * dx;
        x = x1;
        y = y1;

        setPixelVerif(x, y, coul);

        for (y = y1+1; y <= y2; ++y)
        {
            if (d >= 0)
            {
                x += xincr;
                d += aincr;
            }
            else
                d += bincr;

            setPixelVerif(x, y, coul);
        }

    }
    else
    {

        if (x1 > x2)
        {
            echangerEntiers(&x1, &x2);
            echangerEntiers(&y1, &y2);
        }

        yincr = y2 > y1 ? 1 : -1;
        dx = x2 - x1;
        dy = abs(y2 - y1);
        d = 2 * dy - dx;
        aincr = 2 * (dy - dx);
        bincr = 2 * dy;
        x = x1;
        y = y1;

        setPixelVerif(x, y, coul);

        for (x = x1+1; x <= x2; ++x)
        {
            if (d >= 0)
            {
                y += yincr;
                d += aincr;
            }
            else
                d += bincr;

            setPixelVerif(x, y, coul);
        }
    }
}
